!-------------------------------------------------------------------------------
program SplineSurf3D

use sep
use polyfit

implicit none

integer :: nd, ny1, ny2, iy1, iy2, idip
real    :: dy1, dy2, y01, y02, y1, y2
logical :: dip

real, dimension(:,:),   allocatable :: txy, surf
real, dimension(:,:,:), allocatable :: dipsurf

call sep_init(SOURCE)

call from_history('n1',nd)

call from_param( "ny1", ny1)
call from_param( "ny2", ny2)
call from_param( "dy1", dy1)
call from_param( "dy2", dy2)
call from_param( "y01", y01)
call from_param( "y02", y02)
call from_param( "dip", idip, 0);  dip=(idip==1)
call to_history( "n1", ny1)
call to_history( "n2", ny2)
call to_history( "d1", dy1)
call to_history( "d2", dy2)
call to_history( "o1", y01)
call to_history( "o2", y02)

allocate( txy(nd,3) )

call sep_read( txy)

if( dip) then
	call to_history( "n3", 2)
	allocate( dipsurf(ny1,ny2,2) )
	call quadratic_spline_dipsurf( txy, dipsurf, ny1, ny2, dy1, dy2, y01, y02 )
	call sep_write( dipsurf)
	deallocate( dipsurf )
else
	call to_history( "n3", 1)
	allocate( surf(ny1,ny2) )
	call quadratic_spline_surf( txy, surf, ny1, ny2, dy1, dy2, y01, y02 )
	call sep_write( surf)
	deallocate( surf )
end if

deallocate( txy )

call exit(0)

end program SplineSurf3D
