! ---------------------------------------------------------------------------
!  WBMuteWind.f90 - Created by Morgan Brown
!           Tue Dec  3 19:08:56 2002.
! ---------------------------------------------------------------------------
!       Usage: WBMuteWind.x 
!  Parameters: 
! Description: 
! ---------------------------------------------------------------------------
program WBMuteWind

use sep

implicit none

integer :: n1, n2, n3, n4, n5, i2, i3, i4, i5, w0, nw, itau, ndone
real    :: d1, d2, d3, o1, o2, o3

real, dimension(:,:),   allocatable :: tauw_vect
real, dimension(:,:,:), allocatable :: data, wind

call sep_init(SOURCE)

call from_history('n1',n1); call from_history('d1',d1); call from_history('o1',o1)
call from_history('n2',n2); call from_history('d2',d2); call from_history('o2',o2)
call from_history('n3',n3); call from_history('d3',d3); call from_history('o3',o3)
call from_history('n4',n4); 
call from_history('n5',n5); 

call from_param( "nw", nw)
call from_param( "w0", w0, 10)

allocate( tauw_vect(n4,n5), data(n1,n2,n3), wind(nw,n2,n3) )

call to_history('n1',nw); call to_history('d1',d1); call to_history('o1',o1)

call sep_read( tauw_vect, "tauw_vect")

ndone = 0
do i5=1,n5
	do i4=1,n4
		if( mod(ndone*10,n4*n5)==0 ) write(0,"(a,i3,a)") 'done',ndone*100/(n4*n5),'%'
		call sep_read(data)
		itau = nint((tauw_vect(i4,i5)-o1)/d1 + 1) - w0
		itau = min( n1, max( 1, itau) )
		do i3=1,n3
			do i2=1,n2
				wind(:,i2,i3) = data(itau:itau+nw-1,i2,i3)
			end do
		end do
		ndone = ndone + 1
		call sep_write(wind)
	end do
end do

call exit(0)

end program WBMuteWind
