program Depth2time
  use sep
  use lint1
  implicit none

  integer :: nz,nt,i,stat,iz,it,n2,n3
  real    :: dz,dt,tt,frac
  real, pointer, dimension(:) :: depth,time,v,tau,zz

  call sep_init(SOURCE)
  call from_history(nz,n2,n3)
  call from_history('d1',dz)
  call from_param('dt',dt)
  call from_param('nt',nt)

  call to_history('n1',nt)
  call to_history('d1',dt)
  call sep_close()

  allocate(v(nz),tau(nz),zz(nt))
  allocate(depth(nz),time(nt))

  write(0,*) 'reading vel'
  call sep_read(v,'slow')

  tau(1)=0.
  do iz=2,nz
     tau(iz)=tau(iz-1)+dz*v(iz)
  end do

  do it=1,nt
     tt=(it-1)*dt
     
     iz=1
     do while (((iz+1)<nz).and.(tau(iz+1)<tt))
        iz=iz+1
     end do

     ! nearest neighbour
     !zz(it)=(iz-1)*dz

     ! linear interpolation
     frac=(tt-tau(iz))/dt
     zz(it)=(iz-1)*dz+frac*dz

  end do
  call lint1_init(0.,dz,zz)

  do i=1,n2*n3
     depth=0.
     call sep_read(depth)
     stat=lint1_lop(.false.,.false.,depth,time)
     call sep_write(time)
  end do

end program Depth2time





