! PROGRAM       Pickmax
!
! NOTES		
!
! KEYWORDS      
!%

program Pickmax
  use sep
  use tohist
  implicit none
  
  integer :: ndim,fdim,simple,i,j,i1,i2,index,units
  real    :: eps,maxm,val1
  integer, pointer, dimension(:) :: n,nout,center,imax
  real,    pointer, dimension(:) :: o,d,maxtime,filter,oout,dout
  real, dimension(3) :: coords,poly
  real, dimension(7) :: f,a
  real, dimension(7,7) :: B
  
  B(:,1)=(/   1.,  0.,  0.,  0.,-1.,-1.,-1.  /)
  B(:,2)=(/   0.,-0.5,  0.,  0.,0.5, 0., 0.  /)
  B(:,3)=(/   0., 0.5,  0.,  0.,0.5, 0., 0.  /)
  B(:,4)=(/   0.,  0.,-0.5,  0., 0.,0.5, 0.  /)
  B(:,5)=(/   0.,  0., 0.5,  0., 0.,0.5, 0.  /)
  B(:,6)=(/   0.,  0.,  0.,-0.5, 0., 0.,0.5  /)
  B(:,7)=(/   0.,  0.,  0., 0.5, 0., 0.,0.5  /)

  call sep_init(SOURCE)
  ndim=sep_dimension()
  allocate(n(ndim),o(ndim),d(ndim))
  
  call from_param('simple',simple,0)
  call from_param('fdim',fdim,1)
  call from_param('units',units,1)
  call from_history('n',n)
  call from_history('d',d)
  call from_history('o',o)

  if (fdim>=ndim) call seperr('fdim >= ndim')
  allocate(nout(ndim+1),dout(ndim+1),oout(ndim+1))
  if (fdim==1) then
     nout=1;  nout(1:ndim-fdim)=n(fdim+1:ndim)
     dout=1.; dout(1:ndim-fdim)=d(fdim+1:ndim)
     oout=0.; oout(1:ndim-fdim)=o(fdim+1:ndim)
  else
     nout=1;  nout(2:1+ndim-fdim)=n(fdim+1:ndim)
     dout=1.; dout(2:1+ndim-fdim)=d(fdim+1:ndim)
     oout=0.; oout(2:1+ndim-fdim)=o(fdim+1:ndim)
     nout(1)=fdim
  end if
  call to_hist_int_array('n',nout,'out')
  call to_hist_float_array('d',dout,'out')
  call to_hist_float_array('o',oout,'out')

!  d=dout
!  o=oout

  write(0,*) fdim

  eps=1.0e-9
  call sep_close()


  allocate(filter(product(n(1:fdim))),maxtime(fdim),center(fdim),imax(fdim))
  do i=1,fdim
     center(i)=1.5-o(i)/d(i)
     center(i)=max(1,min(center(i),n(i)))
!  write(0,*) i,o(i),d(i),1.5-o(i)/d(i),center(i)
  end do

  do j=1,product(n(1:ndim))/product(n(1:fdim))
     
     call sep_read(filter)

     select case(fdim)
     case (1)
        imax(1)=center(1)
        maxm=filter(imax(1))
        do i=1,n(1)
           if (filter(i).gt.maxm) then
              imax(1)=i
              maxm=filter(i)
           end if
        end do
        i1=imax(1)

	if ((imax(1).eq.1).or.(imax(1).eq.n(1)).or.(simple.eq.1)) then
           maxtime(1)=o(1)+real(i1-1)*d(1)
        else
           coords(1)=o(1)+real(i1-2)*d(1)
           coords(2)=coords(1)+d(1)
           coords(3)=coords(2)+d(1)
           call polyfit(3,coords,filter(i1-1),3,poly)
           maxtime(1)=-poly(2)/(2*poly(3)+eps)
        end if
     case (2)
        imax(1)=center(1)
        imax(2)=center(2)
        maxm=filter(imax(1)+(imax(2)-1)*n(1))
        do i2=1,n(2)
           do i1=1,n(1)
              index=i1+(i2-1)*n(1)
              if (filter(index).gt.maxm) then
                 imax(1)=i1
                 imax(2)=i2
                 maxm=filter(index)
              end if
           end do
        end do
	if ((imax(1).eq.1).or.(imax(1).eq.n(1)).or.(imax(2).eq.1).or.(imax(2).eq.n(2)).or.(simple.eq.1)) then
           maxtime(1)=o(1)+real(imax(1)-1)*d(1)
           maxtime(2)=o(2)+real(imax(2)-1)*d(2)
        else
           index=imax(1)+(imax(2)-1)*n(1)
           val1=filter(index)+eps
           f(1)=1.
           f(2)=filter(index-1)/val1
           f(3)=filter(index+1)/val1
           f(4)=filter(index-n(1))/val1
           f(5)=filter(index+n(1))/val1
           f(6)=0.
           f(7)=0.
           call matmult(0,0,B,f,7,a,7)
           maxtime(1)=o(1)+(real(imax(1)-1)-0.5*a(2)/(a(5)+eps))*d(1)
           maxtime(2)=o(2)+(real(imax(2)-1)-0.5*a(3)/(a(6)+eps))*d(2)
           maxtime(1)=max(o(1),min(maxtime(1),o(1)+(n(1)-1)*d(1)))
           maxtime(2)=max(o(2),min(maxtime(2),o(2)+(n(2)-1)*d(2)))
        end if
        

     case default
        call seperr('dimensionality not implemented')
     end select
     
     if (units==0) then
        do i1=1,fdim
           maxtime(i1)=-maxtime(i1)/d(i1)
        end do
     end if
     call sep_write(maxtime)
  end do

end program Pickmax

subroutine matmult(adj, add, bb,        x,nx,  y,ny) 
  integer ix, iy,  adj, add,              nx,    ny
  real                       bb(ny,nx), x(nx), y(ny)
  if (add==0) then
     if (adj==1) then
        x=0.
     else
        y=0.
     end if
  end if
  do ix= 1, nx 
     do iy= 1, ny
        if( adj == 0 ) then
           y(iy) = y(iy) + bb(iy,ix) * x(ix)
        else
           x(ix) = x(ix) + bb(iy,ix) * y(iy)
        end if
     end do
  end do
end subroutine matmult









