! Warp.x - warp data by linear interpolation
!
! James Rickett - Jul 97
!   rewritten April 2000
!%
program warp
  use sep
  use lint1
  use lint2
  implicit none

  real,    pointer, dimension(:)    :: input,output,shift,d,o
  real,    pointer, dimension(:,:)  :: xy
  integer, pointer, dimension(:)    :: n,naux
  integer :: ndim,sdim,fdim,nn,ninside,noutside,stat,i,j,k,jj,index

  call sep_init(SOURCE)
  ndim=sep_dimension()
  sdim=sep_dimension('shift')

  allocate(n(ndim),d(ndim),o(ndim),naux(sdim))
  call from_history ('n',n)
  call from_history ('d',d)
  call from_history ('o',o)
  call from_aux ('shift','n',naux)
  call sep_close()

  if (sdim==ndim) then
     fdim=1
  else
     fdim=naux(1)
     do i=1,ndim
        naux(i)=naux(i+1)
     end do
     naux(ndim+1)=1
  end if

  do i=1,ndim
     if (n(i).ne.naux(i)) call seperr('dimensions do not match')
  end do

  if (fdim > ndim) call seperr('fdim > ndim')
  nn=product(n)

  ninside=product(n(1:fdim))
  noutside=nn/ninside
     
  allocate(shift(fdim*ninside),input(ninside),output(ninside))
  if (fdim > 1) allocate(xy(ninside,fdim))

  do i=1,noutside

     call sep_read(input)
     call sep_read(shift,'shift')

     select case(fdim)
     case(1)

        do k=1,n(1)
           shift(k)=shift(k)+real(k-1)
        end do

        call lint1_init(0.,1.,shift)
        stat=lint1_lop(.false.,.false.,input,output)

     case (2) 

        do k=1,n(2)
           do j=1,n(1)
              index=j+(k-1)*n(1)
              xy(index,1)=shift(2*(index-1)+1)+real(j-1)
              xy(index,2)=shift(2*(index-1)+2)+real(k-1)
           end do
        end do

        call lint2_init(n(1),n(2),0.,1.,0.,1.,xy)
        stat=lint2_lop(.false.,.false.,input,output)
        
     case default
        call seperr('Dimensionality not yet implemented\n')
     end select

     call sep_write(output,'out')
  end do
end program warp





