module matchprec
  use adj_mod
  use helix
  use polydiv
  implicit none
  logical, parameter, private :: T = .true., F = .false.
  type( filter), private :: aa,bb
  integer :: nd
contains
  subroutine matchprec_init (nd_in,aa_in,bb_in)
    type( filter)    :: aa_in, bb_in
    integer          :: nd_in
    nd = nd_in
    aa = aa_in
    bb = bb_in
  end subroutine matchprec_init
  function matchprec_lop ( adj, add, xx, yy) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: xx,yy 
    real, dimension (size (xx)) :: tt1,tt2
    tt1=0.
    tt2=0.
    call adjnull (adj,add,xx,yy)
    if (adj) then
       call polydiv_init(nd,bb)
       call polydiv_lop2(T,tt2,yy)
       call polydiv_init(nd,aa)
       call polydiv_lop2(T,tt1,tt2)
       call polydiv_lop2(F,tt1,xx)
    else
       call polydiv_init(nd,aa)
       call polydiv_lop2(T,tt1,xx)
       call polydiv_lop2(F,tt1,tt2)
       call polydiv_init(nd,bb)
       call polydiv_lop2(F,tt2,yy)
    end if
    stat=0
  end function matchprec_lop
end module matchprec
